Overview | Package | Class | Tree | Deprecated | Index | Help
| Spring Framework
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.springframework.beans.factory.config
Class BeanReferenceFactoryBean

    java.lang.Object
      org.springframework.beans.factory.config.BeanReferenceFactoryBean

All Implemented Interfaces:
  Aware, BeanFactoryAware, FactoryBean, SmartFactoryBean

    public class BeanReferenceFactoryBean

extends java.lang.Object
implements SmartFactoryBean, BeanFactoryAware

FactoryBean that exposes an arbitrary target bean under a different name.

Usually, the target bean will reside in a different bean definition file, using this FactoryBean to link it in and expose it under a different name. Effectively, this corresponds to an alias for the target bean.

NOTE: For XML bean definition files, an `<alias>` tag is available that effectively achieves the same.

A special capability of this FactoryBean is enabled through its configuration as bean definition: The "targetBeanName" can be substituted through a placeholder, in combination with Spring's `PropertyPlaceholderConfigurer`. Thanks to Marcus Bristav for pointing this out!

Since:
  1.2
Author:
  Juergen Hoeller
See Also:
  `setTargetBeanName(java.lang.String)`, `PropertyPlaceholderConfigurer`

Constructor Summary
`BeanReferenceFactoryBean()`

Method Summary
`java.lang.Object` | `getObject()` Return an instance (possibly shared or independent) of the object managed by this factory.
`java.lang.Class` | `getObjectType()` Return the type of object that this FactoryBean creates, or `null` if not known in advance.
`boolean` | `isEagerInit()` Does this FactoryBean expect eager initialization, that is, eagerly initialize itself as well as expect eager initialization of its singleton object (if any)?
`boolean` | `isPrototype()` Is the object managed by this factory a prototype? That is, will `FactoryBean.getObject()` always return an independent instance?
`boolean` | `isSingleton()` Is the object managed by this factory a singleton? That is, will `FactoryBean.getObject()` always return the same object (a reference that can be cached)?
`void` | `setBeanFactory(BeanFactory beanFactory)` Callback that supplies the owning factory to a bean instance.
`void` | `setTargetBeanName(java.lang.String targetBeanName)` Set the name of the target bean.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### BeanReferenceFactoryBean

    public BeanReferenceFactoryBean()

Method Detail

### setTargetBeanName

    public void setTargetBeanName(java.lang.String targetBeanName)

  Set the name of the target bean.

  This property is required. The value for this property can be substituted through a placeholder, in combination with Spring's PropertyPlaceholderConfigurer.

  Parameters:
    `targetBeanName` - the name of the target bean
  See Also:
    `PropertyPlaceholderConfigurer`

### setBeanFactory

    public void setBeanFactory(BeanFactory beanFactory)

  Description copied from interface: `BeanFactoryAware`
  Callback that supplies the owning factory to a bean instance.

  Invoked after the population of normal bean properties but before an initialization callback such as `InitializingBean.afterPropertiesSet()` or a custom init-method.

  Specified by:
    `setBeanFactory` in interface `BeanFactoryAware`
  Parameters:
    `beanFactory` - owning BeanFactory (never `null`). The bean can immediately call methods on the factory.
  See Also:
    `BeanInitializationException`

### getObject

    public java.lang.Object getObject()
                               throws BeansException

  Description copied from interface: `FactoryBean`
  Return an instance (possibly shared or independent) of the object managed by this factory.

  As with a `BeanFactory`, this allows support for both the Singleton and Prototype design pattern.

  If this FactoryBean is not fully initialized yet at the time of the call (for example because it is involved in a circular reference), throw a corresponding `FactoryBeanNotInitializedException`.

  As of Spring 2.0, FactoryBeans are allowed to return `null` objects. The factory will consider this as normal value to be used; it will not throw a FactoryBeanNotInitializedException in this case anymore. FactoryBean implementations are encouraged to throw FactoryBeanNotInitializedException themselves now, as appropriate.

  Specified by:
    `getObject` in interface `FactoryBean`
  Returns:
    an instance of the bean (can be `null`)
  Throws:
    `BeansException`
  See Also:
    `FactoryBeanNotInitializedException`

### getObjectType

    public java.lang.Class getObjectType()

  Description copied from interface: `FactoryBean`
  Return the type of object that this FactoryBean creates, or `null` if not known in advance.

  This allows one to check for specific types of beans without instantiating objects, for example on autowiring.

  In the case of implementations that are creating a singleton object, this method should try to avoid singleton creation as far as possible; it should rather estimate the type in advance. For prototypes, returning a meaningful type here is advisable too.

  This method can be called before this FactoryBean has been fully initialized. It must not rely on state created during initialization; of course, it can still use such state if available.

  NOTE: Autowiring will simply ignore FactoryBeans that return `null` here. Therefore it is highly recommended to implement this method properly, using the current state of the FactoryBean.

  Specified by:
    `getObjectType` in interface `FactoryBean`
  Returns:
    the type of object that this FactoryBean creates, or `null` if not known at the time of the call
  See Also:
    `ListableBeanFactory.getBeansOfType(java.lang.Class)`

### isSingleton

    public boolean isSingleton()

  Description copied from interface: `FactoryBean`
  Is the object managed by this factory a singleton? That is, will `FactoryBean.getObject()` always return the same object (a reference that can be cached)?

  NOTE: If a FactoryBean indicates to hold a singleton object, the object returned from `getObject()` might get cached by the owning BeanFactory. Hence, do not return `true` unless the FactoryBean always exposes the same reference.

  The singleton status of the FactoryBean itself will generally be provided by the owning BeanFactory; usually, it has to be defined as singleton there.

  NOTE: This method returning `false` does not necessarily indicate that returned objects are independent instances. An implementation of the extended `SmartFactoryBean` interface may explicitly indicate independent instances through its `SmartFactoryBean.isPrototype()` method. Plain `FactoryBean` implementations which do not implement this extended interface are simply assumed to always return independent instances if the `isSingleton()` implementation returns `false`.

  Specified by:
    `isSingleton` in interface `FactoryBean`
  Returns:
    whether the exposed object is a singleton
  See Also:
    `FactoryBean.getObject()`, `SmartFactoryBean.isPrototype()`

### isPrototype

    public boolean isPrototype()

  Description copied from interface: `SmartFactoryBean`
  Is the object managed by this factory a prototype? That is, will `FactoryBean.getObject()` always return an independent instance?

  The prototype status of the FactoryBean itself will generally be provided by the owning `BeanFactory`; usually, it has to be defined as singleton there.

  This method is supposed to strictly check for independent instances; it should not return `true` for scoped objects or other kinds of non-singleton, non-independent objects. For this reason, this is not simply the inverted form of `FactoryBean.isSingleton()`.

  Specified by:
    `isPrototype` in interface `SmartFactoryBean`
  Returns:
    whether the exposed object is a prototype
  See Also:
    `FactoryBean.getObject()`, `FactoryBean.isSingleton()`

### isEagerInit

    public boolean isEagerInit()

  Description copied from interface: `SmartFactoryBean`
  Does this FactoryBean expect eager initialization, that is, eagerly initialize itself as well as expect eager initialization of its singleton object (if any)?

  A standard FactoryBean is not expected to initialize eagerly: Its `FactoryBean.getObject()` will only be called for actual access, even in case of a singleton object. Returning `true` from this method suggests that `FactoryBean.getObject()` should be called eagerly, also applying post-processors eagerly. This may make sense in case of a `singleton` object, in particular if post-processors expect to be applied on startup.

  Specified by:
    `isEagerInit` in interface `SmartFactoryBean`
  Returns:
    whether eager initialization applies
  See Also:
    `ConfigurableListableBeanFactory.preInstantiateSingletons()`

Overview | Package | Class | Tree | Deprecated | Index | Help
| Spring Framework
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD